﻿
Imports System.Data.Common

Class DbZugriff

    Public Function DBZugriff(ByVal DBProviderName As String, ByVal DBConString As String, ByVal CmdStr As String) As DbDataAdapter

        Try
            Dim Factory As DbProviderFactory = DbProviderFactories.GetFactory(DBProviderName)
            Dim Cmd As DbCommand = Factory.CreateCommand
            Dim Conn As DbConnection = Factory.CreateConnection
            Dim Build As DbCommandBuilder = Factory.CreateCommandBuilder
            Dim Adapter As DbDataAdapter = Factory.CreateDataAdapter

            Conn.ConnectionString = DBConString
            Cmd.CommandText = CmdStr

            Try
                Cmd.CommandTimeout = 30 ' SQLCe mag nur 0!
            Catch
            End Try

            Cmd.Connection = Conn
            Cmd.Transaction = Nothing

            Adapter.SelectCommand = Cmd

            Adapter.AcceptChangesDuringFill = True

            Build.ConflictOption = ConflictOption.CompareRowVersion
            Build.SetAllValues = False
            Build.DataAdapter = Adapter

            Adapter.UpdateCommand = Build.GetUpdateCommand()
            Adapter.InsertCommand = Build.GetInsertCommand()
            Adapter.DeleteCommand = Build.GetDeleteCommand()

            Return Adapter

        Catch ex As Exception

            MsgBox(ex.Message)

        End Try

        Return Nothing

    End Function

End Class
