﻿
Imports System.Data.SqlServerCe
Imports System.Data.Common

Imports CDArchiv.DbZugriff

' https://www.vb-paradise.de/index.php/Thread/82646-BindingSource-an-2-Form-übergeben/?pageNo=2 ' original Quelle / Ursprung

Public Class mainform

    Private DbcdarchivAdapter As DbDataAdapter
    Private SQLiteOrSqlCe As String

    Public Sub New(ByVal DBChoice As String)

        InitializeComponent()

        SQLiteOrSqlCe = DBChoice

    End Sub

    Private Sub CDHinzufügenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CDHInzufügenToolStripMenuItem.Click
        Using frmdetail = New frmDetail()
            frmdetail.CdarchivBindingSource.DataSource = Me.CdarchivBindingSource.AddNew
            If frmdetail.ShowDialog(Me) <> Windows.Forms.DialogResult.OK Then
                CdarchivBindingSource.CancelEdit()
            End If
        End Using
    End Sub

    Private Sub mainform_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        Dim chgRowDtb As DataTable = Cdarchiv_dbDataSet3.cdarchiv.GetChanges

        If chgRowDtb IsNot Nothing AndAlso chgRowDtb.Rows.Count > 0 Then

            Dim obj As ToolStripMenuItem = ÄnderungenSpeichernToolStripMenuItem
            Select Case MessageBox.Show("Datenbank sichern?", "Datenbank sichern?", MessageBoxButtons.YesNo)
                Case DialogResult.Yes
                    ÄnderungenSpeichernToolStripMenuItem_Click(obj, e)
                Case DialogResult.No
                    ' MsgBox("Selber schuld wenn Deine Änderungen weg sind!")
            End Select

        End If

    End Sub

    Private Sub mainform_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ReLoad()
    End Sub

    'Programm Beenden durch Menüeintrag mit Abfrage durch MessageBox

    Private Sub ProgrammBeendenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProgrammBeendenToolStripMenuItem.Click

        If MsgBox("Möchten sie die Anwendung wirklich beenden?", MsgBoxStyle.YesNo, "Anwendungsmeldung") = MsgBoxResult.Yes Then
            Me.Close()
        Else

        End If

    End Sub

    Private Sub ÄnderungenSpeichernToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ÄnderungenSpeichernToolStripMenuItem.Click
        Me.Validate()
        Me.CdarchivBindingSource.EndEdit()
        Me.DbcdarchivAdapter.Update(Me.Cdarchiv_dbDataSet3.cdarchiv)
        Cdarchiv_dbDataSet3.cdarchiv.AcceptChanges()
        MsgBox("Update successful")
    End Sub

    Private Sub InfoÜberCDArchivSystem10ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InfoÜberCDArchivSystem10ToolStripMenuItem.Click
        frmAbout.ShowDialog()
    End Sub

    Private Sub ReLoad()
        Dim DBZugriff As New DbZugriff
        Dim ConStr As String = ""
        Dim ProviderName As String = ""
        Dim CmdStr As String = "SELECT [Interpret], [Album], [Genre], [Jahr], [Nummer] FROM [cdarchiv]"
        Select Case SQLiteOrSqlCe
            Case "SqlCe"
                ConStr = "Data Source=|DataDirectory|\cdarchiv_db.sdf"
                ProviderName = "System.Data.SqlServerCe.4.0"
            Case Else ' also auch Choice "SQLite"
                ConStr = "Data Source=|DataDirectory|\cdarchiv.s3db"
                ProviderName = "System.Data.SQLite"
        End Select
        Cdarchiv_dbDataSet3.cdarchiv.Clear()
        If DbcdarchivAdapter Is Nothing Then
            DbcdarchivAdapter = DBZugriff.DBZugriff(ProviderName, ConStr, CmdStr)
        End If
        If DbcdarchivAdapter IsNot Nothing Then
            DbcdarchivAdapter.Fill(Cdarchiv_dbDataSet3.cdarchiv)

            Dim NbrLastRow As Integer = Cdarchiv_dbDataSet3.cdarchiv.Count - 1
            If NbrLastRow > -1 Then
                Dim LastRow As cdarchiv_dbDataSet3.cdarchivRow = Cdarchiv_dbDataSet3.cdarchiv(NbrLastRow)
                Cdarchiv_dbDataSet3.cdarchiv.NummerColumn.AutoIncrementSeed = LastRow.Nummer + 1
            Else
                Cdarchiv_dbDataSet3.cdarchiv.NummerColumn.AutoIncrementSeed = 1
            End If

        End If
    End Sub

    Private Sub NeuLadenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NeuLadenToolStripMenuItem.Click
        ReLoad()
    End Sub

    Private Sub CDBearbeitenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CDBearbeitenToolStripMenuItem.Click
        Using frm = New frmDetail()
            frm.CdarchivBindingSource.DataSource = CdarchivBindingSource.Current
            If frm.ShowDialog(Me) <> Windows.Forms.DialogResult.OK Then
                CdarchivBindingSource.CancelEdit()
            End If
        End Using
    End Sub

    Private Sub CDLöschenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CDLöschenToolStripMenuItem.Click
        CdarchivBindingSource.RemoveCurrent()
    End Sub

    Private Sub DataGridView1_CellContentDoubleClick(sender As System.Object, e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridView1.CellContentDoubleClick
        Dim obj As ToolStripMenuItem = CDBearbeitenToolStripMenuItem
        CDBearbeitenToolStripMenuItem_Click(obj, e)
    End Sub
End Class